| OpendTect 8.0

Loading...
Searching...
No Matches
Classes | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | List of all members
Pick::SetMgr Class Reference
General

Utility to manage pick set lifecycles. Also supports change notifications. More...

`#include <picksetmgr.h>`

Inheritance diagram for Pick::SetMgr:
[legend]

## Classes
struct | BulkChangeData
struct | ChangeData

## Public Member Functions
| SetMgr (const char *nm)
| ~SetMgr ()
RefMan< Set > | get (const char *nm)
ConstRefMan< Set > | get (const char *nm) const
RefMan< Set > | get (const MultiID &mid)
ConstRefMan< Set > | get (const MultiID &mid) const
const MultiID & | get (const Set &s) const
RefMan< Set > | get (int idx)
ConstRefMan< Set > | get (int idx) const
const MultiID & | id (int idx) const
int | indexOf (const char *) const
int | indexOf (const MultiID &) const
int | indexOf (const Set &) const
bool | isChanged (int idx) const
bool | readDisplayPars (const MultiID &, IOPar &) const
void | removeCBs (CallBacker *)
void | reportBulkChange (CallBacker *sender, const BulkChangeData &)
void | reportChange (CallBacker *sender, const ChangeData &)
void | reportChange (CallBacker *sender, const Set &)
void | reportDispChange (CallBacker *sender, const Set &)
void | set (const MultiID &, Set *)
void | setID (int idx, const MultiID &)
void | setUnChanged (int idx, bool yn=true)
int | size () const
Undo & | undo ()
const Undo & | undo () const
bool | writeDisplayPars (const MultiID &, const IOPar &) const
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
virtual BufferString | getName () const
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
virtual void | setName (const char *nm)
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const

## Static Public Member Functions
static void | dumpMgrInfo (StringPairSet &)
static BufferString | getDispFileName (const MultiID &)
static SetMgr & | getMgr (const char *)
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()

## Public Attributes
Notifier< SetMgr > | bulkLocationChanged
| Passes BulkChangeData*.
Notifier< SetMgr > | locationChanged
| Passes ChangeData*.
Notifier< SetMgr > | setAdded
| passes Set*
Notifier< SetMgr > | setChanged
| passes Set*
Notifier< SetMgr > | setDispChanged
| passes Set*
Notifier< SetMgr > | setToBeRemoved
| Passes Set*.

## Protected Member Functions
void | add (const MultiID &, Set *)
RefMan< Set > | find (const char *)
ConstRefMan< Set > | find (const char *) const
RefMan< Set > | find (const MultiID &)
ConstRefMan< Set > | find (const MultiID &) const
MultiID * | find (const Set &) const
void | objectsRm (CallBacker *)
void | objRm (CallBacker *)
void | removeAll ()
void | survChg (CallBacker *)
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const

## Protected Attributes
BoolTypeSet | changed_
TypeSet< MultiID > | ids_
RefObjectSet< Set > | pss_
Undo & | undo_
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Additional Inherited Members
Public Types inherited from ObjectWithName
typedef OD::String | name_type

## Detailed Description

Utility to manage pick set lifecycles. Also supports change notifications.

You can create your own set manager for your own special pick sets. There is a OD-wide Mgr() available which is supposed to hold all 'plain' picksets loaded in the OD-tree.

A new special-purpose manager is created by passing your own name to the static getMgr() method.

<>

## Constructor & Destructor Documentation

## ◆ SetMgr()

Pick::SetMgr::SetMgr | ( | const char * | nm | ) |

creates an unmanaged SetMgr Normally you don't want that, use getMgr() instead

## ◆ ~SetMgr()

Pick::SetMgr::~SetMgr | ( |  | ) |

## Member Function Documentation

## ◆ add()

void Pick::SetMgr::add | ( | const MultiID & | ,
|  | Set * | )
| protected

## ◆ dumpMgrInfo()

static void Pick::SetMgr::dumpMgrInfo | ( | StringPairSet & |  | ) |
| static

## ◆ find() [1/5]

RefMan< Set > Pick::SetMgr::find | ( | const char * |  | ) |
| protected

## ◆ find() [2/5]

ConstRefMan< Set > Pick::SetMgr::find | ( | const char * |  | ) | const
| protected

## ◆ find() [3/5]

RefMan< Set > Pick::SetMgr::find | ( | const MultiID & |  | ) |
| protected

## ◆ find() [4/5]

ConstRefMan< Set > Pick::SetMgr::find | ( | const MultiID & |  | ) | const
| protected

## ◆ find() [5/5]

MultiID * Pick::SetMgr::find | ( | const Set & |  | ) | const
| protected

## ◆ get() [1/7]

RefMan< Set > Pick::SetMgr::get | ( | const char * | nm | ) |
| inline

## ◆ get() [2/7]

ConstRefMan< Set > Pick::SetMgr::get | ( | const char * | nm | ) | const
| inline

## ◆ get() [3/7]

RefMan< Set > Pick::SetMgr::get | ( | const MultiID & | mid | ) |
| inline

## ◆ get() [4/7]

ConstRefMan< Set > Pick::SetMgr::get | ( | const MultiID & | mid | ) | const
| inline

## ◆ get() [5/7]

const MultiID & Pick::SetMgr::get | ( | const Set & | s | ) | const
| inline

## ◆ get() [6/7]

RefMan< Set > Pick::SetMgr::get | ( | int | idx | ) |
| inline

## ◆ get() [7/7]

ConstRefMan< Set > Pick::SetMgr::get | ( | int | idx | ) | const
| inline

## ◆ getDispFileName()

static BufferString Pick::SetMgr::getDispFileName | ( | const MultiID & |  | ) |
| static

## ◆ getMgr()

static SetMgr & Pick::SetMgr::getMgr | ( | const char * |  | ) |
| static

## ◆ id()

const MultiID & Pick::SetMgr::id | ( | int | idx | ) | const

## ◆ indexOf() [1/3]

int Pick::SetMgr::indexOf | ( | const char * |  | ) | const

## ◆ indexOf() [2/3]

int Pick::SetMgr::indexOf | ( | const MultiID & |  | ) | const

## ◆ indexOf() [3/3]

int Pick::SetMgr::indexOf | ( | const Set & |  | ) | const

## ◆ isChanged()

bool Pick::SetMgr::isChanged | ( | int | idx | ) | const

## ◆ objectsRm()

void Pick::SetMgr::objectsRm | ( | CallBacker * |  | ) |
| protected

## ◆ objRm()

void Pick::SetMgr::objRm | ( | CallBacker * |  | ) |
| protected

## ◆ readDisplayPars()

bool Pick::SetMgr::readDisplayPars | ( | const MultiID & | ,
|  | IOPar & | ) const

## ◆ removeAll()

void Pick::SetMgr::removeAll | ( |  | ) |
| protected

## ◆ removeCBs()

void Pick::SetMgr::removeCBs | ( | CallBacker * |  | ) |

## ◆ reportBulkChange()

void Pick::SetMgr::reportBulkChange | ( | CallBacker * | sender,
|  | const BulkChangeData & | )

## ◆ reportChange() [1/2]

void Pick::SetMgr::reportChange | ( | CallBacker * | sender,
|  | const ChangeData & | )

## ◆ reportChange() [2/2]

void Pick::SetMgr::reportChange | ( | CallBacker * | sender,
|  | const Set & | )

## ◆ reportDispChange()

void Pick::SetMgr::reportDispChange | ( | CallBacker * | sender,
|  | const Set & | )

## ◆ set()

void Pick::SetMgr::set | ( | const MultiID & | ,
|  | Set * | )

add, replace or remove (pass null Set ptr). Set is already, or becomes mine Note that replacement will trigger two callbacks

## ◆ setID()

void Pick::SetMgr::setID | ( | int | idx,
|  | const MultiID & | )

## ◆ setUnChanged()

void Pick::SetMgr::setUnChanged | ( | int | idx,
|  | bool | yn = true )

## ◆ size()

int Pick::SetMgr::size | ( |  | ) | const
| inline

## ◆ survChg()

void Pick::SetMgr::survChg | ( | CallBacker * |  | ) |
| protected

## ◆ undo() [1/2]

Undo & Pick::SetMgr::undo | ( |  | ) |

## ◆ undo() [2/2]

const Undo & Pick::SetMgr::undo | ( |  | ) | const

## ◆ writeDisplayPars()

bool Pick::SetMgr::writeDisplayPars | ( | const MultiID & | ,
|  | const IOPar & | ) const

## Member Data Documentation

## ◆ bulkLocationChanged

Notifier<SetMgr> Pick::SetMgr::bulkLocationChanged

Passes BulkChangeData*.

## ◆ changed_

BoolTypeSet Pick::SetMgr::changed_
| protected

## ◆ ids_

TypeSet<MultiID> Pick::SetMgr::ids_
| protected

## ◆ locationChanged

Notifier<SetMgr> Pick::SetMgr::locationChanged

Passes ChangeData*.

## ◆ pss_

RefObjectSet<Set> Pick::SetMgr::pss_
| protected

## ◆ setAdded

Notifier<SetMgr> Pick::SetMgr::setAdded

passes Set*

## ◆ setChanged

Notifier<SetMgr> Pick::SetMgr::setChanged

passes Set*

## ◆ setDispChanged

Notifier<SetMgr> Pick::SetMgr::setDispChanged

passes Set*

## ◆ setToBeRemoved

Notifier<SetMgr> Pick::SetMgr::setToBeRemoved

Passes Set*.

## ◆ undo_

Undo& Pick::SetMgr::undo_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025